#ifndef QFTPWRAPPER_H
#define QFTPWRAPPER_H


/*
'***************************************************************************
'Copyright (C) 2010-2012 KBasic Software: www.kbasic.com. All rights reserved.
'Source codes are created by Bernd Noetscher (or company employees) sales@kbasic.com
'
'You may use this source codes under the terms of the GNU Public License (Version 3) as published
'by the Free Software Foundation.
'
'If you are interested in using the source codes for other licenses or
'commercial development, you must buy commercial licenses from KBasic Software.
'***************************************************************************
*/


#include <QFtp>

#include <QFile>
#include <QDebug>
#include <QEventLoop>
#include <QDir>
#include <QMap>
//QCoreApplication or QApplication must be created before using of this

class Q7BFtpWrapper : public QObject
{
    Q_OBJECT
    QFtp *ftp ;
    QString waitForFtpAndCheckError() ;
    QString lastError ;
    QStringList dwnldFiles ;
    bool createFilesPathsAndDirsList( QString p , QStringList & files , QStringList & dirs ) ;
    QString listFtpDir ( QString curPath , bool r ) ;
    QMap< QString , bool > curLst ;
public :
    Q7BFtpWrapper( QObject * parent = 0 ) ;
    /*
      Functions are syncronous, transfers are binary.
      Return "" on success and error string on error.
      Paths can point to files and directories
    */

    //if toserverurl ends with '/' then file or folder sourcefilename will be placed in directory toserverurl
    //else file sourcefilename will be placed in file toserverurl
    QString FtpUpload( QString sourcefilename , QString host , int port , QString user , QString password , QString toserverurl ) ;

    //if tolocalfile ends with '/' or tolocalfile is an existing directory
    //then file or folder fromurl will be placed in directory tolocalfile
    //else file fromurl will be placed in file tolocalfile
    QString FtpDownload( QString fromurl , QString host , int port , QString user , QString password , QString tolocalfile ) ;
private slots :
    void listInfoSlot ( const QUrlInfo & i ) ;
} ;

#endif // QFTPWRAPPER_H
