/*
    This file containes declaration of   RelativeLayout class, custom layout, which
    keep widgets size equal to parent size, multiplied by special koefficients, which
    are stored as dynamic properties in child widget.
*/

#ifndef RELATIVELAYOUT_H
#define RELATIVELAYOUT_H

#include <QLayout>

class RelativeLayout : public QLayout
{
    Q_OBJECT
    QList < QLayoutItem * > list ;
    QRect prevGeom ;
public :
    explicit RelativeLayout ( QWidget *parent = 0 ) ;
    ~RelativeLayout () ;
    void addItem ( QLayoutItem * item ) ;
    QSize sizeHint () const ;
    QSize minimumSize () const ;
    int count() const ;
    QLayoutItem * itemAt ( int ) const ;
    QLayoutItem * takeAt ( int ) ;
    void setGeometry ( const QRect & rect ) ;
signals :
    void widgetGeomUpdated ( QWidget * w ) ;
public slots :
    
};

#endif // RELATIVELAYOUT_H
