#include "tabordereditwidget.h"
#include <QPainter>
#include <QVariant>
#include <QTextDocument>
#include <QTextCursor>
#include <QDebug>
#include "constants.h"
QList < QPointer < TabOrderEditWidget > > TabOrderEditWidget::list ;
int TabOrderEditWidget::editIndex = 1 ;

void TabOrderEditWidget::finishEditing ()
{
    QList < QWidget * > widgets ;
    for( int i = 1 ; i <= list.count () ; i ++ )
        foreach ( TabOrderEditWidget * w , list )
            if( w->index == i )
            {
                w->target->setProperty ( TABINDEX_PROP_NAME , i ) ;
                widgets.append ( w->target  ) ;
                break ;
            }
    for( int i = 0 ; i < widgets.count () - 1 ; i ++ )
        QWidget::setTabOrder( widgets [ i ] , widgets [ i + 1 ] ) ;

    foreach ( TabOrderEditWidget * w , list )
        w->deleteLater () ;
    list.clear () ;
    editIndex = 1 ;
}

TabOrderEditWidget::TabOrderEditWidget ( QWidget * trg , QWidget *parent ) :
    QLabel ( parent ) , target ( trg )
{
    setProperty ( SEL_SQUARES_MARK , true ) ;
    setTextFormat ( Qt::RichText ) ;
    connect( this , SIGNAL ( linkActivated ( QString ) ) ,
             SLOT ( clickedSlot ( QString ) ) ) ;

    list.append ( this ) ;

    setIndex ( list.count () ) ;
}

void TabOrderEditWidget::clickedSlot ( QString )
{
    foreach ( TabOrderEditWidget * w , list )
    {
        if( w->index == editIndex )
        {
            w->setIndex ( index ) ;
            setIndex ( editIndex ) ;
            editIndex = ( editIndex % list.count ( ) ) + 1 ;
            break ;
        }
    }
}

void TabOrderEditWidget::setIndex ( int i )
{
    QTextDocument d ;
    QTextCursor cur ( & d ) ;
    QTextCharFormat format ;
    format.setFontPointSize ( 23 ) ;
    format.setAnchor ( true ) ;
    format.setAnchorHref ( "hyperlink" ) ;
    index = i ;
    cur.insertText ( QString::number ( index ) , format ) ;
    setText ( d.toHtml () ) ;
}

