#include "widgetfactory.h"
#include <QDebug>
#include <QLayout>
#include "constants.h"
#include "props_functions.h"
#include <QClipboard>
#include <QBuffer>
#include <QMimeData>
#include <QApplication>
WidgetFactory * WidgetFactory::instancePtr = 0 ;

WidgetFactory::WidgetFactory (QObject *parent) :
    QObject (parent)
{
    AbstractCreator * c ;

    // BN

    // *****************************************************************
/*
    c = new QGroupBoxCreator ;
    categories[ "Containers" ].append( c->className() ) ;
    creators << c ;
*/
    c = new QFrameCreator ;
    categories[ "Containers" ].append( c->className() ) ;
    creators << c ;

    c = new QTabWidgetCreator ;
    categories[ "Containers" ].append( c->className() ) ;
    creators << c ;
    noLayoutClassNames.insert ( c->className() ) ;
/*
    c = new QScrollAreaCreator ;
    categories[ "Containers" ].append( c->className() ) ;
    creators << c ;

    c = new QToolBoxCreator ;
    categories[ "Containers" ].append( c->className() ) ;
    creators << c ;

    c = new QStackedWidgetCreator ;
    categories[ "Containers" ].append( c->className() ) ;
    creators << c ;
*/
    // *****************************************************************

    c = new CommandButtonCreator ;
    categories[ "Controls" ].append( c->className() ) ;
    creators << c ;
/*
    c = new CheckBoxCreator ;
    categories[ "Controls" ].append( c->className() ) ;
    creators << c ;

    c = new RadioButtonCreator ;
    categories[ "Controls" ].append( c->className() ) ;
    creators << c ;

    c = new TextBoxCreator ;
    categories[ "Controls" ].append( c->className() ) ;
    creators << c ;

    c = new ComboBoxCreator ;
    categories[ "Controls" ].append( c->className() ) ;
    creators << c ;

    c = new ComboBoxEditableCreator ;
    categories[ "Controls" ].append( c->className() ) ;
    creators << c ;

    c = new LabelCreator ;
    categories[ "Controls" ].append( c->className() ) ;
    creators << c ;

    c = new ListBoxCreator ;
    categories[ "Controls" ].append( c->className() ) ;
    creators << c ;

    c = new ListBoxIconModeCreator ;
    categories[ "Controls" ].append( c->className() ) ;
    creators << c ;

    c = new ProgressBarCreator ;
    categories[ "Controls" ].append( c->className() ) ;
    creators << c ;

    c = new ProgressBarSpinningCreator ;
    categories[ "Controls" ].append( c->className() ) ;
    creators << c ;

    c = new ImageBoxCreator ;
    categories[ "Controls" ].append( c->className() ) ;
    creators << c ;

    c = new TimerCreator ;
    categories[ "Controls" ].append( c->className() ) ;
    creators << c ;

    c = new TreeViewCreator ;
    categories[ "Controls" ].append( c->className() ) ;
    creators << c ;

    c = new ListViewCreator ;
    categories[ "Controls" ].append( c->className() ) ;
    creators << c ;

    c = new ImageButtonCreator ;
    categories[ "Controls" ].append( c->className() ) ;
    creators << c ;

    c = new BoxCreator ;
    categories[ "Controls" ].append( c->className() ) ;
    creators << c ;

    c = new TextBoxPasswordCreator ;
    categories[ "Controls" ].append( c->className() ) ;
    creators << c ;

    c = new LabelLinkCreator ;
    categories[ "Controls" ].append( c->className() ) ;
    creators << c ;

    c = new LabelLinkCreator ;
    categories[ "Controls" ].append( c->className() ) ;
    creators << c ;

    c = new LineHorizontalCreator ;
    categories[ "Controls" ].append( c->className() ) ;
    creators << c ;

    c = new LineVerticalCreator ;
    categories[ "Controls" ].append( c->className() ) ;
    creators << c ;

    c = new FormViewCreator ;
    categories[ "Controls" ].append( c->className() ) ;
    creators << c ;
*/
    // *****************************************************************
/*
    c = new QWidgetCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;
*/
    c = new QLabelCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;

    c = new QComboBoxCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;

    c = new QFontComboBoxCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;

    c = new QPushButtonCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;

    c = new QCheckBoxCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;

    c = new QRadioButtonCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;

    c = new QLineEditCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;    
/*
    c = new QTextEditCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;

    c = new QPlainTextEditCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;

    c = new QSpinBoxCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;

    c = new QDoubleSpinBoxCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;

    c = new QToolButtonCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;

    c = new QCommandLinkButtonCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;

    c = new QDialogButtonBoxCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;

    c = new QListViewCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;

    c = new QTreeViewCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;

    c = new QTableViewCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;

    c = new QColumnViewCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;

    c = new QListWidgetCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;

    c = new QTreeWidgetCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;

    c = new QTableWidgetCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;

    c = new QMdiAreaCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;

    c = new QDockWidgetCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;

    c = new QTimeEditCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;

    c = new QDateEditCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;

    c = new QDateTimeEditCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;

    c = new QDialCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;

    c = new QScrollBarHorizontalCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;

    c = new QScrollBarVerticalCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;

    c = new QSliderHorizontalCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;

    c = new QSliderVerticalCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;

    c = new QTextBrowserCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;


    c = new QGraphicsViewCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;

    c = new QCalendarWidgetCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;

    c = new QLCDNumberCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;

    c = new QProgressBarCreator ;
    categories[ "Qt controls" ].append( c->className() ) ;
    creators << c ;
*/
    // *****************************************************************
	
    foreach ( AbstractCreator * cr , creators )
        creatorsHash.insert ( cr->className () , cr ) ;
}

QWidget * WidgetFactory::newWidgetByClassNameP ( QString cn , QString name )
{
    if ( creatorsHash.contains ( cn ) )
    {
        QWidget * w = creatorsHash.value ( cn )->createForPalette() ;
        w->setObjectName ( name ) ;
        w->setProperty( DELETED_PROP_NAME , false ) ;


        w->setProperty( REL_L , 50 ) ;
        w->setProperty( REL_R , 50 ) ;
        w->setProperty( REL_T , 50 ) ;
        w->setProperty( REL_B , 50 ) ;

        w->setProperty( EN_REL_L , false ) ;
        w->setProperty( EN_REL_R , false ) ;
        w->setProperty( EN_REL_T , false ) ;
        w->setProperty( EN_REL_B , false ) ;

        QVariantMap mpr ;
        mpr.insert( "visible" , true ) ;
        w->setProperty( METAPROPERTY_REPLACEMENTS , mpr ) ;
        w->setFocusPolicy( Qt::TabFocus ) ;
        w->setFocus() ;
        return w ;
    }
    return 0 ;
}
QWidget * WidgetFactory::newWidgetByClassName ( QString cn , QString name , bool uName )
{
    if ( creatorsHash.contains ( cn ) )
    {
        QWidget * w = creatorsHash.value ( cn )->createWidget() ;
        uName ? w->setObjectName ( creatorsHash.value ( cn )->getUniqueName( name ) )
              : w->setObjectName ( name ) ;
        w->setProperty( DELETED_PROP_NAME , false ) ;


        w->setProperty( REL_L , 50 ) ;
        w->setProperty( REL_R , 50 ) ;
        w->setProperty( REL_T , 50 ) ;
        w->setProperty( REL_B , 50 ) ;

        w->setProperty( EN_REL_L , false ) ;
        w->setProperty( EN_REL_R , false ) ;
        w->setProperty( EN_REL_T , false ) ;
        w->setProperty( EN_REL_B , false ) ;

        QVariantMap mpr ;
        mpr.insert( "visible" , true ) ;
        w->setProperty( METAPROPERTY_REPLACEMENTS , mpr ) ;
//        w->setFocusPolicy( Qt::TabFocus ) ;
//        w->setFocus() ;
        emit widgetsChanged() ;
        return w ;
    }
    return 0 ;
}

WidgetFactory * WidgetFactory::instance ()
{
    if ( ! instancePtr )
        instancePtr = new WidgetFactory ( 0 ) ;
    return instancePtr ;
}

QList < QWidget * > WidgetFactory::newAll ()
{
    QList < QWidget * > ret ;
    foreach ( AbstractCreator * cr , creators )
    {
        ret << cr->createForPalette () ;
        ret.last ()->setObjectName ( "" ) ;
    }

    return ret ;
}

bool WidgetFactory::isClassSupported ( QString s )
{
    return creatorsHash.contains ( s ) ;
}

bool WidgetFactory::addChildToWidget ( QWidget * parent , QWidget * child )
{
    bool ret = false ;
    QWidget * p = findKnownParent( parent ) ;
    if ( p )
    {
        QString parentCN = p->metaObject ()->className () ;
        AbstractCreator * cr = creatorsHash.value ( parentCN ) ;
        ret = cr->addChildToWidget ( p , child ) ;

        p->update();
    }
    else if (parent)
    {
        child->setParent ( parent ) ;
        if( parent->layout() )
            parent->layout()->addWidget( child ) ;

        ret = true ;
    }

    if ( p && ! noLayoutClassNames.contains ( p->metaObject ()->className () ) )
    {
        if ( child->parentWidget () && ! child->parentWidget ()->layout () )
            child->parentWidget ()->setLayout ( new RelativeLayout( child->parentWidget () ) ) ;

        child->parentWidget ()->layout ()->addWidget ( child ) ;
    }
//    if ( ! ret )
//        child->hide () ;
    emit widgetsChanged() ;
    return ret ;
}

void WidgetFactory::addEventFilterToWidget ( QWidget * parent , QWidget * child )
{
    QString childCN = child->metaObject ()->className () ;
    if ( creatorsHash.contains ( childCN ) )
        creatorsHash.value ( childCN )->addEventFilterToWidget(  parent , child ) ;
    else
        child->installEventFilter( parent ) ;
}

QList< QPointer< QWidget > >  WidgetFactory::getChildren ( QWidget * parent )
{
    QList< QPointer< QWidget > > list ;
    QWidget * p = /*findKnownParent*/( parent ) ;

    if ( p && isClassSupported( p->metaObject ()->className () ) )
    {
        QString parentCN = p->metaObject ()->className () ;

        list =  creatorsHash.value ( parentCN )->getChildren ( p ) ;
    }
    else if ( ! findKnownParent ( parent ) )
    {
        foreach ( QObject * w , parent->children () )
        {
            if ( w->property ( SEL_SQUARES_MARK ).toBool () == true )
                continue ;
            else
            {
                QWidget * widget = qobject_cast< QWidget * > ( w ) ;
                if ( widget )
                    list.append ( widget ) ;
            }
        }

    }
    for ( int i = 0 ; i < list.count() ; i ++ )
        if( ! isClassSupported( list [ i ]->metaObject()->className() ) )
            list.removeAt ( i ) ;
    return list ;
}

QStringList WidgetFactory::getClassNames ()
{
    QStringList ret ;
    foreach ( AbstractCreator * cr , creators )
        ret << cr->className () ;
    return ret ;
}

QStringList WidgetFactory::getClassNamesByCat ( QString c )
{
    return categories [ c ] ;
}

QWidget * WidgetFactory::findKnownParent( QWidget * child )
{
    QWidget * p = child ;
    while( p != 0  )
    {
        if( isClassSupported( p->metaObject()->className() ) )
            return p ;
        p = p->parentWidget() ;
    }
    return 0 ;
}

QPointer< QWidget > WidgetFactory::removeChildFromWidget (  QWidget * parent, QWidget * w  )
{
    QWidget * p = findKnownParent( parent ) ;
    if ( p )
    {
        if( w->parentWidget() && w->parentWidget()->layout() )
            w->parentWidget()->layout()->removeWidget( w );
        QString parentCN = p->metaObject ()->className () ;
        creatorsHash.value ( parentCN )->removeChildFromWidget( p , w ) ;
    }
    if ( w->parentWidget () && w->parentWidget ()->layout () )
        w->parentWidget ()->layout ()->removeWidget( w ) ;
    emit widgetsChanged() ;
    return w ;
}

QList < QWidget * > WidgetFactory::newByCategory ( QString c )
{
    QList < QWidget * > ret ;
    QStringList l = categories.value( c ) ;
    foreach ( QString cn , l )
        ret << creatorsHash.value( cn )->createForPalette() ;
    return ret ;
}

QList < QPointer < QAction > > QTabWidgetCreator::getActions (QPointer<QWidget> w)
{
    currentWidget = qobject_cast < QTabWidget * > ( w.data () ) ;
    return actions.values() ;
}

QStringList WidgetFactory::getCategories ()
{
    return categories.keys() ;
}

bool QTabWidgetCreator::addChild (  QPointer<QWidget> parent , QPointer<QWidget> w )
{
    QTabWidget * r = qobject_cast < QTabWidget * > ( parent ) ;
    if ( r )
    {
        r->setUpdatesEnabled ( false ) ;
        bool b = false ;
        if ( QString ( w->metaObject()->className() ) == "QFrame" )
        {
            QStringList allNames ;
            for ( int i = 0 ; i < r->count() ; i ++ )
                allNames.append ( r->tabText ( i ) ) ;
            QString newName;
            QString templ = "Tab %1";
            int t = 1;

            while ( allNames.contains( newName = templ.arg(t ++) ) );

            if( r->indexOf( w ) == - 1 )
            {
                qobject_cast < QFrame * > ( w )->setLineWidth ( 0 ) ;
                //w->setParent ( r ) ;
                r->addTab ( w , newName ) ;
                r->update() ;
                b = true ;
            }
        }
        else if (r->currentIndex() != -1 )
        {
            w->setParent(r->widget(r->currentIndex())) ;
            if (r->widget(r->currentIndex())->layout())
                r->widget(r->currentIndex())->layout()->addWidget(w);
            r->update() ;
            w->show();
            w->update();
            b =  true ;
        }
        r->setUpdatesEnabled ( true ) ;

        return b ;
    }
    else
    {
        w->setParent ( parent ) ;
        return false ;
    }
}

QList < QPointer < QAction > > WidgetFactory::getSpecialActions ( QWidget * w )
{
    QString CN = w->metaObject ()->className () ;
    if ( creatorsHash.contains ( CN ) )
        return creatorsHash.value ( CN )->getActions ( w ) ;
    return QList < QPointer < QAction > > () ;
}

void WidgetFactory::assignProperties (QWidget * w, QVariantMap pr)
{
    QString CN = w->metaObject ()->className () ;
    if ( creatorsHash.contains ( CN ) )
        creatorsHash.value ( CN )->assignPropertiesToWidget ( w , pr) ;
}

void WidgetFactory::copyProperties ( QWidget * w , QVariantMap & props , bool deleteId )
{
    QString CN = w->metaObject ()->className () ;
    if ( creatorsHash.contains ( CN ) )
        creatorsHash.value ( CN )->copyPropertiesFromWidget ( w , props , deleteId ) ;
}

void AbstractCreator::basicCopyProperties(QPointer<QWidget> w, QVariantMap & props , bool deleteId )
{
    if ( deleteId )
        allInst.removeAll ( w.data() ) ;
    for ( int i = 0 ; i < PF::metaPropertyCount ( w ) ; i ++ )
        props.insert( PF::metaPropertyName( w ,i ) , PF::readMetaProperty( w , i ) ) ;
    foreach( QByteArray pn , w->dynamicPropertyNames() )
        props.insert ( QString( pn ) ,
                      w->property( pn.data() ) ) ;
}

void AbstractCreator::copyPropertiesFromWidget(QPointer<QWidget> w , QVariantMap & props , bool deleteId )
{
    basicCopyProperties ( w , props , deleteId ) ;
    copyProperties(w , props , deleteId);
}

QWidget * QTabWidgetCreator::createP ()
{
    QTabWidget * tw = qobject_cast < QTabWidget * > ( create() ) ;
    QFrame * nt = qobject_cast < QFrame * > ( WidgetFactory::instance()->
                                              newWidgetByClassNameP( "QFrame" , "QFrame1" ) ) ;
    nt->setLineWidth ( 0 ) ;
    tw->addTab ( nt , "Tab 1" ) ;
    tw->setCurrentIndex ( - 1 ) ;

    return tw ;
}

void QTabWidgetCreator::newTabSlot ()
{
    if (currentWidget)
    {
        QFrame * nt = qobject_cast < QFrame * > ( WidgetFactory::instance()->newWidgetByClassName( "QFrame" , "" , false ) ) ;
        nt->setLayout ( new RelativeLayout ( nt ) ) ;
        nt->setLineWidth ( 0 ) ;

        WidgetFactory::instance()->copyToCB( nt ) ;
        WidgetFactory::instance()->emitPasteNeeded();
    }
}

void QTabWidgetCreator::removeTabSlot ()
{
    if (currentWidget && currentWidget->count () > 0 )
        WidgetFactory::instance()->emitDeleteNeeded (
                    QList < QPointer <QWidget > > () << currentWidget->currentWidget() ) ;
}

void AbstractCreator::basicAssignProps( QPointer<QWidget> w , QVariantMap pr)
{
    QVariant fr ;
    if ( pr.contains ( "frameRect" ) )
        fr = pr.value( "frameRect") ;
    for ( int i = 0 ; i < pr.count () ; i ++ )
    {

        if( pr.keys () [ i ] != "objectName" )
            PF::writeProperty( w , pr.keys () [ i ] , pr.values () [ i ] ) ;
        else
                PF::writeProperty( w , "objectName" , getUniqueName(pr.values () [ i ].toString ())) ;
    }
    if ( w->layout() == 0 )
    {
        if ( pr [ LAYOUT_KIND_PROP_NAME ] == "horizontal" )
            w->setLayout ( new QHBoxLayout ( w ) ) ;
        else if ( pr [ LAYOUT_KIND_PROP_NAME ] == "vertical" )
            w->setLayout ( new QVBoxLayout ( w ) ) ;
        else if ( pr [ LAYOUT_KIND_PROP_NAME ] == "relative" )
            w->setLayout ( new RelativeLayout( w ) ) ;
    }
    PF::writeProperty ( w , "frameRect"  , fr ) ;
}

void AbstractCreator::assignPropertiesToWidget(QPointer<QWidget> w , QVariantMap pr)
{
    basicAssignProps ( w , pr ) ;
    assignProperties ( w , pr ) ;
}

void QTabWidgetCreator::assignProperties (QPointer<QWidget> w, QVariantMap pr)
{
    QTabWidget * tw = qobject_cast < QTabWidget * > (w);

    if ( pr.contains("tabs") )
    {
        QVariantMap tabs = pr[ "tabs" ].toMap() ;
        QStringList tabs_order = pr[ "tabs_order" ].toStringList() ;

        QMap < QString , QWidget * > wm ;
        for (int i = 0 ; i < tw->count() ; i ++ )
        {
            QString k = tw->widget( i )->objectName() ;
            wm.insert( k , tw->widget( i ) ) ;
        }
        if ( ! tabs_order.isEmpty() )
            tw->clear () ;

        for (int i = 0 ; i < tabs_order.count() ; i ++ )
        {
            QString k = tabs_order[ i ] ;
            QWidget * w = wm.value( k ) ;
            if ( w == 0 )
                w = wm.values() [ i ] ;
            QString tn ;
            if ( tabs.contains( k ) )
                tn = tabs [ k ].toString() ;
            if ( tn == "" )
                tn = tabs_order[ i ] ;
            tw->addTab( w , tn ) ;

        }
        tw->setCurrentIndex(pr["currentIndex"].toInt());
    }
}

void updateRecursive ( QWidget * w )
{
    foreach( QObject * o , w->children() )
    {
        QWidget * child = qobject_cast < QWidget * > ( o ) ;
        if ( child )
            updateRecursive( child ) ;
    }
    w->update() ;
}

void WidgetFactory::copyToCB( QWidget * child )
{
    QByteArray serializedWidgets ;
    QVariantMap sectionWidgets ;

    QVariantMap map = createChildPropList ( child , QPoint () , false ) ;
    sectionWidgets.insert ( "widget" , map ) ;

    QBuffer buf ;
    buf.open ( QIODevice::WriteOnly ) ;
    QDataStream stream ( & buf ) ;
    stream << sectionWidgets ;
    serializedWidgets = buf.data () ;

    QMimeData *mimeDataClbd = new QMimeData ;

    mimeDataClbd->setData ( "serialized/objects" , serializedWidgets ) ;
    QClipboard *clbd = QApplication::clipboard () ;
    clbd->clear () ;
    clbd->setMimeData ( mimeDataClbd ) ;
}

QVariantMap WidgetFactory::createChildPropList ( QWidget * w , QPoint posDelta , bool deleteId )
{
    QVariantMap ret ;

    QVariantMap props ;

    if( w->parent() )
    {
        props.insert( Z_ORDER , w->parent()->children().indexOf( w ) ) ;
        w->setProperty( Z_ORDER , w->parent()->children().indexOf( w ) ) ;
    }

    props.insert ( "WidgetClassName" , w->metaObject ()->className () ) ;

    copyProperties ( w , props , deleteId ) ;

    if ( findKnownParent( w->parentWidget () ) == 0  )
    {
        QPoint p = props.value ( "pos" ).toPoint () ;
        p -=  posDelta ;
        props [ "pos" ] = p ;
    }
    QVariantMap childProps ;
    foreach ( QWidget * cw , getChildren( w ) )
    {

        if ( cw && ! cw->property( DELETED_PROP_NAME ).toBool() )
            childProps.insertMulti ( cw->metaObject ()->className () , createChildPropList ( cw , posDelta , deleteId ) ) ;
    }

    if ( w->layout() )
    {
        if ( qobject_cast < QHBoxLayout * > ( w->layout() ) )
            props [ LAYOUT_KIND_PROP_NAME ] = "horizontal" ;

        else if ( qobject_cast < QVBoxLayout * > ( w->layout() ) )
            props [ LAYOUT_KIND_PROP_NAME ] = "vertical" ;

        else if ( qobject_cast < RelativeLayout * > ( w->layout() ) )
            props [ LAYOUT_KIND_PROP_NAME ] = "relative" ;
    }

    ret.insert ( "widget" , props ) ;
    ret.insert ( "children" , childProps ) ;
    return ret ;
}

QList<QPointer<QWidget> > WidgetFactory::restoreWidgets ( QWidget * parent , QVariantMap data , QWidget * mainFilter , bool uName )
{
    QList < QPointer < QWidget > > widgets ;
    QVariantMap curWidgetMap = data.value ( "widget" ).toMap () ;
    QVariantMap children = data.value ( "children" ).toMap () ;
    QWidget * w = newWidgetByClassName (
                curWidgetMap.value ( "WidgetClassName" ).toString () , curWidgetMap["objectName"].toString() , uName ) ;
    if ( w )
    {
        widgets.append ( w ) ;
        if ( addChildToWidget ( parent , w ) )
        {
            QMap < int , QPointer<QWidget> > zReorderMap ;
            for ( int i = 0 ; i < children.count () ; i ++ )
            {
                QList < QPointer < QWidget > > wl = restoreWidgets ( w , children.values () [ i ].toMap () , mainFilter , uName) ;
                if( ! wl.isEmpty() )
                    if( wl.first()->parentWidget() )
                        zReorderMap.insert( wl.first()->property( Z_ORDER ).toInt()
                                            , wl.first() ) ;  // root widget of tree, which is produced by restoreWidgets
                widgets.append ( wl ) ;
            }

            addEventFilterToWidget ( mainFilter , w ) ;
            w->setProperty( Z_ORDER , curWidgetMap[ Z_ORDER ] ) ;

            curWidgetMap.remove ( "objectName" ) ;

            if ( zReorderMap.count() > 1 )
            {
                QMap < int , QPointer<QWidget> >::iterator i = zReorderMap.end() - 1 ;
                while ( i != zReorderMap.begin() )
                {
                    QPointer<QWidget> higher = i.value() ;
                    -- i ;
                    QPointer<QWidget> lower = i.value() ;
                    lower->stackUnder( higher ) ;
                }
            }
            if ( w->layout() )
                foreach ( QObject * li , w->children() )
                    if ( qobject_cast < QWidget * > ( li ) )
                        w->layout()->addWidget ( qobject_cast < QWidget * > ( li ) ) ;

            assignProperties ( w , curWidgetMap ) ;
        }
    }
    return widgets ;
}
